`isop.calc1set` <-
function(raw, verbose=TRUE)
{

isop.criteriumS <- function (coords.x,coords)
    (( sum(coords.x <= coords) == length(coords) ) & ( sum(coords.x < coords) > 1 )) |
    (( sum(coords.x >= coords) == length(coords) ) & ( sum(coords.x > coords) > 1 ))

isop.criteriumD <- function (coords.x,coords)
    ( sum(coords.x < coords) > 0 ) & ( sum(coords.x > coords) > 0 )

isop.criteriumT <- function (coords.x,coords)
#    sum(coords.x == coords) > 0
	!all(coords.x == coords)
	

isop.generateSDT <- function(x, nx, criterium)
{
  crit <-  function (index.x,co) 
    criterium( x[index.x,], co )
  mat.lr <- function(index)
    sum( nx[ sapply(index.x,crit, x[index,])] )
  index.x <- 1:length(nx)
  sapply(index.x, mat.lr)
} 


  xnx <- as.data.frame(table(as.data.frame(raw)))
  xnx <- xnx[xnx$Freq!=0,]
  x   <- isop.asmatrix(xnx[,1:(dim(xnx)[2]-1)])
  nx  <- xnx$Freq

  if ( verbose ) {
    print("calculating concordant matrix")
    print(c("duration:", durS<-system.time(Smat <- isop.generateSDT(x, nx, isop.criteriumS))[3], "seconds"))
    print("calculating discordant matrix")
    print(c("duration:", durD<-system.time(Dmat <- isop.generateSDT(x, nx, isop.criteriumD))[3], "seconds"))
  } else {
    Smat <- isop.generateSDT(x, nx, isop.criteriumS)
    Dmat <- isop.generateSDT(x, nx, isop.criteriumD)
  }

  n <- sum(nx)
  pairs <- n^2
  ns <- sum(nx*Smat)  
  nd <- sum(nx*Dmat)
  nt <- pairs-(ns+nd)
  nss <- sum(nx*Smat^2)  
  nsd <- sum(nx*Smat*Dmat)
  ndd <- sum(nx*Dmat^2)

  ps <- ns/(ns+nd+nt)
  pd <- nd/(ns+nd+nt)
  pt <- nt/(ns+nd+nt)
  pss <- nss/(ns+nd+nt)^2
  pdd <- ndd/(ns+nd+nt)^2
  psd <- nsd/(ns+nd+nt)^2

  gamma <- (ns - nd) / (ns + nd)
  stddev <- sqrt( (16/(1-pt)^4) * (ps^2*pdd-2*ps*pd*psd+pd^2*pss) )
  comp <- ns + nt
  isoto <- comp / pairs
  stderr <- stddev / sqrt(n)
  z <- gamma/stddev
  ubas <- sqrt( 2*(1-gamma^2)/ps+pd )
  

res<-list(ns = ns,
	nd = nd,
	nt = nt,
	nss = nss,
	ndd = ndd,
	nsd = nsd,
	ps = ps,
	pd = pd,
	pt = pt,
	pss = pss,
	pdd = pdd,
	psd = psd,
	predictability = gamma,
	stddev = stddev,
	isotonicity = isoto,
	compatibility = comp,
	n = n,
	z = z,
	stderr = stderr,
	ubas = ubas)

}

