`isop.calc2set` <-
function(raw,set1,set2, verbose=TRUE)
{
  
isop.dominate <- function (coords.x,coords)
# (( sum(coords.x >= coords) == length(coords) ) & ( sum(coords.x > coords) > 0 )) 
	( all(coords.x >= coords) & any(coords.x > coords) ) 
	

isop.criteriumS2set <- function (co.x,co,indexset1,indexset2)
    (( if( isop.dominate(co.x[indexset1], co[indexset1]) ) 
           isop.dominate(co.x[indexset2], co[indexset2])
       else F )
    |
     ( if( isop.dominate(co[indexset1], co.x[indexset1]) )
           isop.dominate(co[indexset2], co.x[indexset2])
       else F ))

isop.criteriumD2set <- function (co.x,co,indexset1,indexset2)
    (( isop.dominate(co.x[indexset1], co[indexset1]) &
       isop.dominate(co[indexset2], co.x[indexset2]) )
    |
    ( isop.dominate(co[indexset1], co.x[indexset1]) &
      isop.dominate(co.x[indexset2], co[indexset2]) ))

isop.criteriumT2set <- function (co.x,co,indexset1,indexset2)
    all(co.x[indexset1] == co[indexset1]) |
    all(co.x[indexset2] == co[indexset2])



isop.generateSDT2set <- function(x,nx,set1,set2, criterium)
{
  
  crit <-  function (index.x,co,indexset1,indexset2) 
    criterium(x[index.x,] , co ,indexset1,indexset2) 

  mat.lr <- function(index)
  { 
    sum( nx[ sapply( index.x,crit, x[index,] ,indexset1,indexset2 ) ] )
  }
  
  index.x <- 1:length(nx)

  indexset1 <- 1:length(set1)
  indexset2 <- length(set1)+1:length(set2)

  sapply(index.x, mat.lr)
} 


  xnx <- as.data.frame(table(as.data.frame(cbind(raw[,set1],raw[,set2]))))
  xnx <- xnx[xnx$Freq!=0,]
  x   <- isop.asmatrix(xnx[,1:(dim(xnx)[2]-1)])
  nx  <- xnx$Freq

  if ( verbose ) {
    print("calculating concordant matrix")
    print(paste("duration:", durS<-system.time(Smat <- isop.generateSDT2set(x, nx, set1, set2, isop.criteriumS2set))[3], "seconds"))
    print("calculating discordant matrix")
    print(paste("duration:", durD<-system.time(Dmat <- isop.generateSDT2set(x, nx, set1, set2, isop.criteriumD2set))[3], "seconds"))
    print("calculating tied matrix")
    print(paste("duration:", durT<-system.time(Tmat <- isop.generateSDT2set(x, nx, set1, set2, isop.criteriumT2set))[3], "seconds"))
    print(paste("Overall time: ",durS+durD+durT))
  } else {
    Smat <- isop.generateSDT2set(x, nx, set1, set2, isop.criteriumS2set)
    Dmat <- isop.generateSDT2set(x, nx, set1, set2, isop.criteriumD2set)
    Tmat <- isop.generateSDT2set(x, nx, set1, set2, isop.criteriumT2set)
  }

  n <- sum(nx)
  pairs <- n^2

  ns <- sum(nx*Smat)  
  nd <- sum(nx*Dmat)
  nt <- pairs - ns - nd 

  nss <- sum(nx*Smat^2)  
  ndd <- sum(nx*Dmat^2)
  nsd <- sum(nx*Smat*Dmat)

  ps <- ns/(ns+nd+nt)
  pd <- nd/(ns+nd+nt)
  pt <- nt/(ns+nd+nt)
  pss <- nss/(ns+nd+nt)^2
  pdd <- ndd/(ns+nd+nt)^2
  psd <- nsd/(ns+nd+nt)^2

  gamma <- (ns - nd) / (ns + nd)
  stddev <- sqrt( (16/(1-pt)^4) * (ps^2*pdd-2*ps*pd*psd+pd^2*pss) )
  compatibility <- ns + nt


  isoto <- compatibility / (ns+nd+nt)
  stderr <- stddev / sqrt(n)
  z <- gamma/stderr
  ubas <- sqrt( 2*(1-gamma^2)/ps+pd )
  

res<-list(ns = ns,
	nd = nd,
	nt = nt,
	nss = nss,
	ndd = ndd,
	nsd = nsd,
	ps = ps,
	pd = pd,
	pt = pt,
	pss = pss,
	pdd = pdd,
	psd = psd,
	predictability = gamma,
	stddev = stddev,
	isotonicity = isoto,
	compatibility = compatibility,
	n = n,
	z = z,
	stderr = stderr,
	ubas = ubas)

}

