\name{isop.calc1set}
\alias{isop.calc1set}
\title{ ISOP model for one set of items }
\description{
  The function calculates nonparametric indices for testing the validity of an ISOP-Model, suggested by Scheiblechner, for a given set of items. 
}
\usage{
isop.calc1set(raw, verbose = TRUE)
}
\arguments{
  \item{raw}{ The data ISOP should be applied on }
  \item{verbose}{ Print information about progress }
}
\value{
  \item{ns, nd, nt, nss, ndd, nsd}{Frequencies of concordant, discordant and tied vectors}
  \item{ps, pd, pt, pss, pdd, psd}{Probabilities of concordant, discordant and tied vectors}
  \item{predictability}{ Multivariate index of ordinal association. Varies between -1 and +1. Does not include ties.}
  \item{stddev}{Standard devation of predictability}
  \item{isotonicity}{Nonparametric measure of positive diagonalization of an ordered contingency table. Varies between 0 and +1. Includes ties.}
  \item{compatibility}{Number of pairs concordant or tied}
  \item{n}{Number of response vectors}
  \item{z}{z-value of normal distribution}
  \item{stderr}{Standard error of predictability}
  \item{ubas}{Upper bound of asymptotic }
}
\references{ 
Hartmann Scheiblechner (2003) 
Nonparametric IRT: Testing the bi-isotonicity of isotonic probabilistic models (ISOP) 
\emph{Psychometrika}, \bold{68}, 1, 79--96
}
\author{ Stefan Nachtnebel }

\seealso{ \code{\link{isop.calc2set}}}

\keyword{ nonparametric }
\keyword{ multivariate }
