\name{isop.plot3d}
\alias{isop.plot3d}
\title{ Generates 3D-Plot of underlying system characteristics table }
\description{
  This function is a wrapper for persp, setting some default values in the arguments
}
\usage{
isop.plot3d(sysch, theta = 300, phi = 30, expand = 0.5, col = heat.colors(prod(dim(what))), bg = "white", xlab = "response vectors", ylab = "items", zlab = "discrimination" , ticktype = "detailed")
}

\arguments{
  \item{sysch}{ Table of system characteristics genererated by \code{\link{isop.sysch}} }
  \item{theta}{ see: \code{\link{persp}} }
  \item{phi}{ see: \code{\link{persp}} }
  \item{expand}{ see: \code{\link{persp}} }
  \item{col}{ see: \code{\link{persp}} }
  \item{bg}{ see: \code{\link{persp}} }
  \item{xlab}{ see: \code{\link{persp}} }
  \item{ylab}{ see: \code{\link{persp}} }
  \item{zlab}{ see: \code{\link{persp}} }
  \item{ticktype}{ see: \code{\link{persp}} }
}
\details{
   This function is a wrapper for \code{persp}. 
}
\references{ 
Hartmann Scheiblechner (2003) 
Nonparametric IRT: Testing the bi-isotonicity of isotonic probabilistic models (ISOP) 
\emph{Psychometrika}, \bold{68}, 1, 79--96
}
\author{ Stefan Nachtnebel }

\seealso{ \code{\link{isop.sysch}}, \code{\link{isop.plotFreqs}}, \code{\link{persp}} }
