\name{isop.testItems}
\alias{isop.testItems}

\title{ Item selection } }
\description{
  This function automates the item selection via isop.calc2set. The items contained by \code{selection} are tested individually with the whole set of items specified in items
}
\usage{
isop.testItems(raw, selection = 1:dim(raw)[2], items = selection, verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{raw}{ The data, to be analysed: see \code{\link{isop.calc2set}} }
  \item{selection}{ A set of items, that should be tested  }
  \item{items}{ A pool of items, the items in selection should be tested with. Typically the same set as selection. }
  \item{verbose}{ Print status messages: see \code{\link{isop.calc2set}} }
}
\details{
   Example for distinction between \code{selection} and \code{items}: If you want to determine, how well the items with indices 1; 2 and 3 individually fit to the set of items 1;2;3;4;5, \code{selection} has to be c(1,2,3) and \code{items} has to be c(1,2,3,4,5).
}
\value{
  \item{ns, nd, nt, nss, ndd, nsd}{Frequencies of concordant, discordant and tied vectors}
  \item{ps, pd, pt, pss, pdd, psd}{Probabilities of concordant, discordant and tied vectors}
  \item{predictability}{ Multivariate index of ordinal association. Varies between -1 and +1. Does not include ties.}
  \item{stddev}{Standard devation of predictability}
  \item{isotonicity}{Nonparametric measure of positive diagonalization of an ordered contingency table. Varies between 0 and +1. Includes ties.}
  \item{compatibility}{Number of pairs concordant or tied}
  \item{n}{Number of response vectors}
  \item{z}{z-value of predictability}
  \item{stderr}{Standard error of predictability}
  \item{ubas}{Upper bound of asymptotic }
}
\author{ Stefan Nachtnebel }
\seealso{ \code{\link{isop.calc2set}} }

